package com.dr.plugins.example;

import android.content.Context;
import android.graphics.Bitmap;

import POSAPI.POSInterfaceAPI;
import POSAPI.POSUSBAPI;
import POSSDK.POSSDK;

public class PrintUtil {
    //PortType value
    public static final int USBPORT = 1;		//USB
    public static final int SERIALPORT = 2;		//COM
    public static final int WIFIPORT = 3;		//WIFI
    public static final int BLUETOOTHPORT = 4;	//Bluetooth

    private static POSInterfaceAPI interface_usb;
    public static POSSDK pos_usb = null;

    //打开设备
    private static boolean openDevice(Context context) {
        if (interface_usb != null) {
            interface_usb.CloseDevice();
        }
        interface_usb = new POSUSBAPI(context);
        if (interface_usb.OpenDevice(5455,5455) == POSInterfaceAPI.POS_SUCCESS) {
            pos_usb = new POSSDK(interface_usb);
            return true;
        } else {
            interface_usb = null;
            pos_usb = null;
        }
        return false;
    }

    public static int printBitmap(Bitmap img_name, Context context) {
        //先检测状态是否正确
        int result = verify(context);
        if (result == 0) {
            //设置偏移
            pos_usb.standardModeSetPrintAreaWidth(0, 65535);
            //打印
            pos_usb.imageStandardModePrint(img_name, 33, 0, 65535);
            //走纸3行
            pos_usb.systemFeedLine(3);
            //切割纸张
            pos_usb.systemCutPaper(POSSDK.CutFullImmdediately, 0);
        }
        return result;
    }

    //查看设备状态
    //0正常 1异常
    public static int verify(Context context) {
        if (pos_usb == null) {
            if (!openDevice(context)) {
                //离线状态
                return 1;
            }
        }
        //成功返回0
        if (checkPrintStatus()==0) {
            return 0;
        }
        //尝试重新连接
        if (openDevice(context)) {
            if (checkPrintStatus()==0) {
                return 0;
            }
        }
        return 1;
    }

    //查询打印机状态
    //0正常 1异常
    public static int checkPrintStatus() {
        int bufferSize=4;
        byte[] statusBuffer = new byte[bufferSize];
        if(pos_usb == null) {
            return 1;
        }
        int status = pos_usb.systemQueryStatus(statusBuffer, bufferSize, USBPORT);
        if (status != POSInterfaceAPI.POS_SUCCESS) {
            return 1;
        }
        return 0;
    }
}
